<template>
  <div class="site-container">
    <Ariane type="breadcrumb" :breadcrumbs="breadcrumbs" :params="params" />

    <div class="grid catalog-container">
      <template v-if="albumCount">
        <div class="cta-to-complete" style="width: 100%; margin-top: 40px">
          <p class="heading--xl">
            <strong>{{
              $tc('profile.album', albumCount, { count: albumCount })
            }}</strong>
            {{ $t('wishlist.inMyWishlist') }}
          </p>
          <CatalogButton :is-subscription="isSubscription" />
        </div>

        <h2 class="heading--lg">{{ $t('breadcrumb.wishlist') }}</h2>

        <div id="content" class="grid-col-6">
          <div class="block no-border">
            <div class="block-content product-list grid">
              <SmallAlbum
                v-for="album of displayedList"
                :key="album.id"
                :album="album"
                :is-subscription="false"
                :for-search="true"
                :with-close-box="true"
                @delete-album="removeFromWishlist(album)"
              />
              <EmptyAlbum v-for="empty of emptyAlbums" :key="empty" />
            </div>
          </div>

          <Pagination
            v-if="albumCount > paginationLimit"
            :current-page="currentPage"
            :total-page="totalPage"
            :items-per-page="paginationLimit"
            @updatePage="updatePage"
          />

          <div class="block-shop-price">
            <div class="block-price-list block-price-total">
              <div class="left">
                <p>{{ $t('common.total') }}</p>
              </div>
              <div class="right">
                <p>
                  <span class="price totalprice" v-html="total.html"></span>
                </p>
              </div>
            </div>

            <a
              href="#"
              class="button button_blue"
              @click.prevent="emptyWishlist()"
              >{{ $t('wishlist.emptyMyWishlist') }}</a
            >
            <a
              href="#"
              class="button button_orange pull-right"
              @click.prevent="addWishlistToCart()"
              >{{ $t('catalog.add_basket') }}</a
            >
          </div>
        </div>
      </template>
      <template v-else-if="!$fetchState.pending">
        <WishlistEmpty :is-subscription="isSubscription" />
        <!-- show 'reco'/'you may also like' slicks -->
        <div class="promo"></div>
      </template>
    </div>
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import SmallAlbum from '~/components/SmallAlbum'
import EmptyAlbum from '~/components/Empty/EmptyAlbum'
import Pagination from '~/components/ui/Pagination'
import CatalogButton from '~/components/ui/CatalogButton'
import WishlistEmpty from '~/components//WishlistEmpty'

export default {
  name: 'Wishlist',
  components: {
    Ariane,
    SmallAlbum,
    EmptyAlbum,
    CatalogButton,
    Pagination,
    WishlistEmpty
  },

  async fetch() {
    await this.loadWishlist(this.currentPage)
  },

  data() {
    return {
      title: this.$t('breadcrumb.wishlist'),
      breadcrumbs: [this.$t('breadcrumb.home'), this.$t('breadcrumb.wishlist')],
      params: [`/${this.$i18n.locale}`, null],
      albums: null,
      albumCount: 0,
      total: null,

      currentPage: 1,
      paginationLimit: 18,
      totalPage: undefined,
      displayedList: [],

      seriesNewReleases: {
        reference: 'news'
      },
      seriesUserSuggestions: {
        reference: 'user-suggestions'
      }
    }
  },

  computed: {
    isSubscription() {
      return this.$utils.aboArea()
    },

    emptyAlbums() {
      const array = []

      if (this.displayedList.length) {
        for (let i = this.displayedList.length % 6; i < 6; i++) {
          array.push(i)
        }
      }

      return array
    }
  },

  methods: {
    async loadWishlist(page) {
      const offset = (page - 1) * this.paginationLimit

      try {
        const { data } = await this.$axios.get(
          `/${this.$i18n.locale}/api/wishlist/${offset}`
        )

        this.total = data.total
        this.albumCount = data.count

        this.initPagination()

        if (!this.albums) {
          this.albums = {
            pages: []
          }
        }

        this.albums.pages[page - 1] = data.albums

        await this.setDisplayed()
      } catch (e) {
        console.log(`Error loading user wishlist: ${e.message}`)
        this.$nuxt.error({
          statusCode: 503,
          message: 'Error loading user wishlist'
        })
      }
    },

    initPagination() {
      this.totalPage = Math.ceil(this.albumCount / this.paginationLimit)
      if (this.currentPage > this.totalPage) {
        this.currentPage = this.totalPage
      }
      if (this.currentPage <= 0) {
        this.currentPage = 1
      }
    },

    updatePage(currentPage) {
      this.currentPage = currentPage

      this.setDisplayed()
    },

    async setDisplayed() {
      if (this.albumCount) {
        if (!this.albums.pages[this.currentPage - 1])
          await this.loadWishlist(this.currentPage)

        this.displayedList = this.albums.pages[this.currentPage - 1]
      }
    },

    async emptyWishlist() {
      try {
        const { data } = await this.$axios.get(
          `/${this.$i18n.locale}/api/wishlist/remove-all`
        )

        this.albums = []
        this.albumCount = data['count']
        this.total = null

        this.displayedList = []
        this.initPagination()
      } catch (e) {
        console.log(`Error clear user wishlist: ${e.message}`)
        this.$nuxt.error({
          statusCode: 503,
          message: 'Error clear user wishlist'
        })
      }
    }
  },

  head() {
    return {
      titleTemplate: this.title
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/fallbacks/_fallbacks.scss"
></style>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/v6-block-shop/_block-shop.scss"
></style>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/cta-to-complete/_cta-to-complete.scss"
></style>

<style lang="scss">
.right,
.pull-right {
  float: right;
}
</style>
